unit ImportHVQB;

interface


// set Databasename, username and password needet for the
// connection to the database.

procedure HVQB_SetDatabaseName ( db : pChar );
procedure HVQB_SetUserName     ( us : pChar );
procedure HVQB_SetPassword     ( pw : pChar );

// returns the resulting query string or nothing
function  HVQB_ExecuteQBuilder : pChar;

// Serve some additional Information

// note : you have to ask for the end of information after
// you have called an HVQB_NextXXX Procedure
// the following code will not work properly

{ example :

   while not ( HVQB_GroupByFieldsEnd ) do
    begin
      currentField := HVQB_NextGroupField
    end;

   better use

   repeat
    currentField := HVQB_NextGroupField
   until ( HVQB_GroupByFieldsEnd ) }

// must be called once before using NextGroupByField
// ( is the same as first on a dataset)
function HVQB_InitGroupBy : boolean;

// returns the actual grouped field and goes to the next
// the return format is FieldName=FieldAlias for a field
// declaration like FIELD AS FIELDALIAS or only the Field Name
function  HVQB_NextGroupByField : pChar;

// returns true if the actual field is the last field
function  HVQB_GroupByFieldsEnd : boolean;

// the same as above for fields in the order by clause
function  HVQB_InitOrderBy : boolean;
function  HVQB_NextOrderByField : pChar;
function  HVQB_OrderByFieldsEnd : boolean;

// the same as above for Joins, result string is RELATION1=RELATION2
function  HVQB_InitJoinedRelations: boolean;
function  HVQB_NextJoinedRelation : pChar;
function  HVQB_JoinedRelationsEnd : boolean;

// works only inside a NextJoinedRelation loop
// result = RELATION1.JOINFIELD=RELATION2.JOINFIELD
function  HVQB_NextJoin           : pChar;
function  HVQB_JoinsEnd           : boolean;

implementation

procedure HVQB_SetDatabaseName ( db : pChar );  external 'HVQBDLL.DLL';
procedure HVQB_SetUserName     ( us : pChar );  external 'HVQBDLL.DLL';
procedure HVQB_SetPassword     ( pw : pChar );  external 'HVQBDLL.DLL';
function  HVQB_ExecuteQBuilder : pChar;         external 'HVQBDLL.DLL';

function  HVQB_InitGroupBy      : boolean;      external 'HVQBDLL.DLL';
function  HVQB_NextGroupByField : pChar;        external 'HVQBDLL.DLL';
function  HVQB_GroupByFieldsEnd : boolean;      external 'HVQBDLL.DLL';

function  HVQB_InitOrderBy      : boolean;      external 'HVQBDLL.DLL';
function  HVQB_NextOrderByField : pChar;        external 'HVQBDLL.DLL';
function  HVQB_OrderByFieldsEnd : boolean;      external 'HVQBDLL.DLL';

function  HVQB_InitJoinedRelations:boolean;     external 'HVQBDLL.DLL';
function  HVQB_NextJoinedRelation : pChar;      external 'HVQBDLL.DLL';
function  HVQB_JoinedRelationsEnd : boolean;    external 'HVQBDLL.DLL';

function  HVQB_NextJoin           : pChar;      external 'HVQBDLL.DLL';
function  HVQB_JoinsEnd           : boolean;    external 'HVQBDLL.DLL';

end.
